/* Marquage de mots-clefs
   Auteur : bruno.mathieu@freesurf.fr
   Date :  01-08-2005
   Licence : Domaine public
*/

<?php

// l'ouverture du tag pour mettre en valeur le mot clef
global $debut;
// la fermeture du tag pour mettre en valeur le mot clef
global $fin;

/* l'expression rgulire : je marque les mots entre 
   tirets, ce n'est certainement pas le meilleur marqueur :-(
*/
global $reg;
$reg = "(-[^ ><.!?;]*-[ .!?;,><:&\)])";

/* il suffit de passer color dans l'url pour surligner (dbogage) */
if (isset($_GET['color']))
{
  $debut='<span style="background-color: #C0C0F0">';
  $fin = '</span>';
}

/* construction de la liste des mots clefs, en supprimant les doublons, sans tenir compte de la casse */

function mots_clef($string) { 
  global $reg;
  preg_match_all ($reg, $string, $matches);
  $mots = Array();
  for ($i=0; $i< count($matches[0]); $i++) {
    // je supprime des deux tirets et le caractre suivant le deuxime
    $mots[$i] = substr($matches[0][$i],1,-2);
    // je remplace les _ par des espaces (permettre des groupes de mots)
    $mots[$i] = preg_replace("/_/"," ",$mots[$i]);
  }
  $mots = array_unique($mots);
  return implode(", ", $mots);
}

/* suppression des marqueurs */
function sans_mots_clef($string) 
{
  global $debut;
  global $fin;
  global $reg;
  preg_match_all ($reg, $string, $matches);
  $mots = Array();
  for ($i=0; $i< count($matches[0]); $i++) {
    $mots[$i] = $debut.substr($matches[0][$i],1,-2).$fin;
    $mots[$i] = preg_replace("/_/"," ",$mots[$i]);
    $matches[0][$i] = "/".substr($matches[0][$i],0,-1)."/";
  }

  return preg_replace($matches[0],$mots,$string);
}

?>
